from jeb.api import IScript
from jeb.api.ui import View
from jeb.api.ui import JebUI
from jeb.api.ui import CodePosition

from xml.etree.ElementTree import *

import sys
sys.setdefaultencoding('utf-8') # for multibyte language

class ManifestJump(IScript):
    def run(self, jeb):
        jeb = jeb
        ui = jeb.getUI()

        if not ui.isViewVisible(View.Type.MANIFEST):
            print "ManifestJump: This script shoule be used in manifest view."
            return

        view = ui.getView(View.Type.MANIFEST)
        target = view.getActiveItem()
        print "caret item: " + target

        if target is None:
            return

        # get package name
        xml = jeb.getManifest()
        root = fromstring(xml)
        package = root.attrib['package']

        # determine target names
        if target.startswith('.'):
            target = package + target
        elif target.find(u'.') == -1:
            target = package + '.' + target


        target = "L%s;" % target.replace('.', '/') 

        # if target class is included in dex, jump to target class
        if target in jeb.getDex().getClassSignatures(False):
            print('jump to ' + target)
            ui.focusView(View.Type.ASSEMBLY)
            asm_view = ui.getView(View.Type.ASSEMBLY)
            asm_view.setCodePosition(CodePosition(target))
        else:
            print('jump target is not found')



